package org.processmining.causalactivitymatrix.algorithms;

import org.processmining.causalactivitymatrix.filters.CausalityBasedFilter;
import org.processmining.causalactivitymatrix.filters.CausalityBasedFilterManager;
import org.processmining.causalactivitymatrix.models.CausalActivityMatrix;
import org.processmining.causalactivitymatrix.parameters.FilterLogUsingMatrixParameters;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.log.models.EventLogArray;
import org.processmining.log.models.impl.EventLogArrayFactory;

public class FilterLogArrayUsingMatrixAlgorithm {

	public EventLogArray apply(PluginContext context, EventLogArray logs, CausalActivityMatrix matrix,
			FilterLogUsingMatrixParameters parameters) {
		CausalityBasedFilter filter = CausalityBasedFilterManager.getInstance().getFilter(parameters.getFilter());
		EventLogArray filteredLogs = EventLogArrayFactory.createEventLogArray();
		filteredLogs.init();
		for (int i = 0; i < logs.getSize(); i++) {
			filteredLogs.addLog(filter.apply(logs.getLog(i), matrix, parameters));
		}
		return filteredLogs;
	}
}
