package org.processmining.causalactivitymatrix.algorithms;

import org.deckfour.xes.model.XLog;
import org.processmining.causalactivitymatrix.filters.CausalityBasedFilter;
import org.processmining.causalactivitymatrix.filters.CausalityBasedFilterManager;
import org.processmining.causalactivitymatrix.models.CausalActivityMatrix;
import org.processmining.causalactivitymatrix.parameters.FilterLogUsingMatrixParameters;
import org.processmining.framework.plugin.PluginContext;

public class FilterLogUsingMatrixAlgorithm {
	
	public XLog apply(PluginContext context, XLog log, CausalActivityMatrix matrix,
			FilterLogUsingMatrixParameters parameters) {
		CausalityBasedFilter filter = CausalityBasedFilterManager.getInstance().getFilter(parameters.getFilter());
		return filter.apply(log, matrix, parameters);
	}

}
