package org.processmining.causalactivitymatrix.algorithms;

import org.processmining.causalactivitymatrix.models.CausalActivityMatrix;
import org.processmining.causalactivitymatrix.modifiers.CausalActivityMatrixModifier;
import org.processmining.causalactivitymatrix.modifiers.impl.CausalActivityMatrixConcurrencyRatioModifier;
import org.processmining.causalactivitymatrix.modifiers.impl.CausalActivityMatrixIncludeThresholdModifier;
import org.processmining.causalactivitymatrix.modifiers.impl.CausalActivityMatrixStackedModifier;
import org.processmining.causalactivitymatrix.modifiers.impl.CausalActivityMatrixZeroValueModifier;
import org.processmining.causalactivitymatrix.parameters.ModifyCausalActivityMatrixParameters;
import org.processmining.framework.plugin.PluginContext;

public class ModifyCausalActivityMatrixAlgorithm {

	public CausalActivityMatrix apply(PluginContext context, CausalActivityMatrix matrix,
			ModifyCausalActivityMatrixParameters parameters) {
		CausalActivityMatrixModifier modifier = new CausalActivityMatrixStackedModifier(
				new CausalActivityMatrixZeroValueModifier(parameters.getZeroValue()),
				new CausalActivityMatrixConcurrencyRatioModifier(parameters.getConcurrencyRatio()),
				new CausalActivityMatrixIncludeThresholdModifier(parameters.getIncludeThreshold()));
		return modifier.apply(matrix);
	}
}
