package org.processmining.causalactivitymatrix.algorithms;

import javax.swing.JComponent;
import javax.swing.JPanel;

import org.processmining.causalactivitymatrix.models.CausalActivityMatrix;
import org.processmining.causalactivitymatrix.plugins.ujmp.MatrixGridPanel;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.ujmp.core.Matrix;
import org.ujmp.core.MatrixFactory;
import org.ujmp.core.enums.ValueType;
import org.ujmp.jmathplot.AbstractJMathPlotPanel;

public class VisualizeCausalActivityMatrixGridAlgorithm {

	public JComponent apply(UIPluginContext context, CausalActivityMatrix matrix) {
		return embed(new MatrixGridPanel(getMatrix(matrix)));
	}

	private JPanel embed(AbstractJMathPlotPanel panel) {
		JPanel p = new JPanel();
		p.add(panel);
		panel.repaintUI();
		return panel;
	}

	private Matrix getMatrix(CausalActivityMatrix matrix) {
		int n = matrix.getActivities().size();
		Matrix m = MatrixFactory.dense(ValueType.DOUBLE, n, n);
		for (int c = 0; c < n; c++) {
			m.setColumnLabel(c, matrix.getActivities().get(c).getId());
		}
		for (int r = 0; r < n; r++) {
			m.setRowLabel(r, matrix.getActivities().get(r).getId());
			for (int c = 0; c < n; c++) {
				Double value = matrix.getValue(matrix.getActivities().get(c), matrix.getActivities().get(r));
				m.setAsDouble(value, r, c);
			}
		}
		return m;
	}
}
