package org.processmining.causalactivitymatrix.algorithms;

import javax.swing.JComponent;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableModel;

import org.processmining.causalactivitymatrix.models.CausalActivityMatrix;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.framework.util.ui.widgets.ProMTable;

public class VisualizeCausalActivityMatrixTableAlgorithm {

	public JComponent apply(UIPluginContext context, CausalActivityMatrix matrix) {
		int n = matrix.getActivities().size();
		TableModel model = new DefaultTableModel(n + 1, n + 1);
		for (int c = 0; c < n; c++) {
			model.setValueAt(matrix.getActivities().get(c).getId(), 0, c + 1);
		}
		for (int r = 0; r < n; r++) {
			model.setValueAt(matrix.getActivities().get(r).getId(), r + 1, 0);
			for (int c = 0; c < n; c++) {
				model.setValueAt(matrix.getValue(matrix.getActivities().get(r), matrix.getActivities().get(c)), r + 1, c + 1);
			}
		}
		ProMTable table = new ProMTable(model);
		table.setColumnSelectionAllowed(true);
		return table;
	}
}
