package org.processmining.causalactivitymatrix.connections;

import org.deckfour.xes.model.XLog;
import org.processmining.causalactivitymatrix.models.CausalActivityMatrix;
import org.processmining.causalactivitymatrix.parameters.FilterLogUsingMatrixParameters;
import org.processmining.framework.connections.impl.AbstractConnection;

public class FilterLogUsingMatrixConnection extends AbstractConnection {

	public final static String LOG = "Log";
	public final static String MATRIX = "Matrix";
	public final static String FILTEREDLOG = "Filtered Log";

	private FilterLogUsingMatrixParameters parameters;

	public FilterLogUsingMatrixConnection(XLog log, CausalActivityMatrix matrix, XLog filteredLog,
			FilterLogUsingMatrixParameters parameters) {
		super("Filter Log using Matrix Connection");
		put(LOG, log);
		put(MATRIX, matrix);
		put(FILTEREDLOG, filteredLog);
		this.parameters = parameters;
	}

	public FilterLogUsingMatrixParameters getParameters() {
		return parameters;
	}
}
