package org.processmining.causalactivitymatrix.connections;

import org.processmining.causalactivitymatrix.models.CausalActivityMatrix;
import org.processmining.causalactivitymatrix.parameters.ModifyCausalActivityMatrixParameters;
import org.processmining.framework.connections.impl.AbstractConnection;

public class ModifyCausalActivityMatrixConnection extends AbstractConnection {

	public final static String MATRIX = "Matrix";
	public final static String MODIFIEDMATRIX = "Modified Matrix";

	private ModifyCausalActivityMatrixParameters parameters;

	public ModifyCausalActivityMatrixConnection(CausalActivityMatrix matrix, CausalActivityMatrix modifiedMatrix,
			ModifyCausalActivityMatrixParameters parameters) {
		super("Modify Matrix Connection");
		put(MATRIX, matrix);
		put(MODIFIEDMATRIX, modifiedMatrix);
		this.parameters = parameters;
	}

	public ModifyCausalActivityMatrixParameters getParameters() {
		return parameters;
	}
}

