package org.processmining.causalactivitymatrix.dialogs;

import info.clearthought.layout.TableLayout;
import info.clearthought.layout.TableLayoutConstants;

import java.awt.Dimension;
import java.util.List;

import javax.swing.DefaultListModel;
import javax.swing.JPanel;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import org.processmining.causalactivitymatrix.filters.CausalityBasedFilter;
import org.processmining.causalactivitymatrix.parameters.FilterParameter;
import org.processmining.framework.util.ui.widgets.ProMList;

public class FilterPanel extends JPanel {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1707197959798125607L;

	public FilterPanel(List<CausalityBasedFilter> filters, final FilterParameter filterParameter) {
		double size[][] = { { TableLayoutConstants.FILL }, { TableLayoutConstants.FILL } };
		setLayout(new TableLayout(size));
		

		setOpaque(false);
		
		DefaultListModel<String> listModel = new DefaultListModel<String>();
		for (CausalityBasedFilter filter: filters) {
			listModel.addElement(filter.getName());
		}
		final ProMList<String> list = new ProMList<String>("Select filter", listModel);
		list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		final String defaultMiner = filterParameter.getFilter();
		list.setSelection(defaultMiner);
		list.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent e) {
				List<String> selected = list.getSelectedValuesList();
				if (selected.size() == 1) {
					filterParameter.setFilter(selected.get(0));
				} else {
					/*
					 * Nothing selected. Revert to selection of default classifier.
					 */
					list.setSelection(defaultMiner);
					filterParameter.setFilter(defaultMiner);
				}
			}
		});
		list.setPreferredSize(new Dimension(100, 100));
		add(list, "0, 0");

	}

}

