package org.processmining.causalactivitymatrix.filters.impl;

import org.deckfour.xes.classification.XEventClass;
import org.deckfour.xes.model.XEvent;
import org.deckfour.xes.model.XTrace;
import org.processmining.causalactivitymatrix.filters.CausalityBasedFilterParameters;
import org.processmining.causalactivitymatrix.models.CausalActivityMatrix;

public class CausalityBasedAverageFilter extends CausalityBasedAbstractFilter {

	public double getValue(XTrace trace, CausalActivityMatrix matrix, CausalityBasedFilterParameters parameters) {
		if (trace.size() < 2) {
			return 1.0;
		}
		double sumValue = 0.0;
		XEventClass firstActivity;
		XEventClass secondActivity = null;
		for (XEvent event : trace) {
			firstActivity = secondActivity;
			secondActivity = new XEventClass(parameters.getClassifier().getClassIdentity(event), 0);
			if (firstActivity != null) {
				sumValue += matrix.getValue(firstActivity, secondActivity);
			}
		}
		return sumValue / (trace.size() - 1);
	}

	public String getName() {
		return "Average Causality";
	}

}
