package org.processmining.causalactivitymatrix.filters.impl;

import org.deckfour.xes.classification.XEventClass;
import org.deckfour.xes.model.XEvent;
import org.deckfour.xes.model.XTrace;
import org.processmining.causalactivitymatrix.filters.CausalityBasedFilterParameters;
import org.processmining.causalactivitymatrix.models.CausalActivityMatrix;

public class CausalityBasedCountFilter  extends CausalityBasedAbstractFilter {

	public double getValue(XTrace trace, CausalActivityMatrix matrix, CausalityBasedFilterParameters parameters) {
		if (trace.size() < 2) {
			return 1.0;
		}
		XEventClass[] activities = new XEventClass[2];
		activities[1] = null;
		int sumValue = 0;
		for (XEvent event : trace) {
			activities[0] = activities[1];
			activities[1] = new XEventClass(parameters.getClassifier().getClassIdentity(event), 0);
			if (activities[0] != null) {
				double value = (matrix.getValue(activities[0], activities[1]) + 2) / 2;
				if (value < 0.0) {
					sumValue++;				
				}
			}
		}
		return (-1.0 * sumValue) / (trace.size() - 1);
	}

	public String getName() {
		return "Causality Count";
	}

}