package org.processmining.causalactivitymatrix.filters.impl;

import org.deckfour.xes.classification.XEventClass;
import org.deckfour.xes.model.XEvent;
import org.deckfour.xes.model.XTrace;
import org.processmining.causalactivitymatrix.filters.CausalityBasedFilterParameters;
import org.processmining.causalactivitymatrix.models.CausalActivityMatrix;

public class CausalityBasedMinimalFilter extends CausalityBasedAbstractFilter {

	public double getValue(XTrace trace, CausalActivityMatrix matrix, CausalityBasedFilterParameters parameters) {
		double minValue = 1.0;
		XEventClass firstActivity;
		XEventClass secondActivity = null;
		StringBuffer buf = new StringBuffer();
		String sep = "[";
		for (XEvent event : trace) {
			firstActivity = secondActivity;
			secondActivity = new XEventClass(parameters.getClassifier().getClassIdentity(event), 0);
			buf.append(sep + secondActivity);
			sep = ",";
			if (firstActivity != null) {
				double value = matrix.getValue(firstActivity, secondActivity);
				if (value < minValue) {
					minValue = value;
				}
			}
		}
		buf.append("] " + minValue);
		parameters.displayMessage(buf.toString());
		return minValue;
	}

	public String getName() {
		return "Minimal Causality";
	}

}
