package org.processmining.causalactivitymatrix.filters.impl;

import org.deckfour.xes.classification.XEventClass;
import org.deckfour.xes.model.XEvent;
import org.deckfour.xes.model.XTrace;
import org.processmining.causalactivitymatrix.filters.CausalityBasedFilterParameters;
import org.processmining.causalactivitymatrix.models.CausalActivityMatrix;

public class CausalityBasedProductFilter extends CausalityBasedAbstractFilter {

	public double getValue(XTrace trace, CausalActivityMatrix matrix, CausalityBasedFilterParameters parameters) {
		// TODO Auto-generated method stub
		XEventClass[] activities = new XEventClass[2];
		activities[1] = null;
		double productValue = 1.0;
		for (XEvent event : trace) {
			activities[0] = activities[1];
			activities[1] = new XEventClass(parameters.getClassifier().getClassIdentity(event), 0);
			if (activities[0] != null) {
				double value = (matrix.getValue(activities[0], activities[1]) + 2) / 2;
				productValue *= value;
			}
		}
		return (productValue * 2) - 2;
	}

	public String getName() {
		return "Causality Product";
	}

}
