package org.processmining.causalactivitymatrix.modifiers.impl;

import java.util.ArrayList;
import java.util.List;

import org.processmining.causalactivitymatrix.models.CausalActivityMatrix;
import org.processmining.causalactivitymatrix.modifiers.CausalActivityMatrixModifier;

public class CausalActivityMatrixStackedModifier implements CausalActivityMatrixModifier {

	private List<CausalActivityMatrixModifier> modifiers;

	public CausalActivityMatrixStackedModifier(CausalActivityMatrixModifier... modifiers) {
		this.modifiers = new ArrayList<CausalActivityMatrixModifier>();
		for (CausalActivityMatrixModifier modifier : modifiers) {
			this.modifiers.add(modifier);
		}
	}

	public CausalActivityMatrix apply(CausalActivityMatrix matrix) {
		CausalActivityMatrix modifiedMatrix = matrix;
		for (CausalActivityMatrixModifier modifier : modifiers) {
			modifiedMatrix = modifier.apply(modifiedMatrix);
		}
		return modifiedMatrix;
	}
}
