package org.processmining.causalactivitymatrix.parameters;

import org.deckfour.xes.model.XLog;
import org.processmining.causalactivitymatrix.filters.CausalityBasedFilterManager;
import org.processmining.causalactivitymatrix.filters.CausalityBasedFilterParameters;

public class FilterLogUsingMatrixParameters extends CausalityBasedFilterParameters implements FilterParameter {

	private String filter;
	private boolean tryConnections;
	
	public FilterLogUsingMatrixParameters(XLog log) {
		super(log);
		setFilter(CausalityBasedFilterManager.getInstance().getFilter(null).getName());
		setTryConnections(true);
	}

	public FilterLogUsingMatrixParameters(FilterLogUsingMatrixParameters parameters) {
		super(parameters);
		setFilter(parameters.getFilter());
		setTryConnections(parameters.isTryConnections());
	}
	
	public String getFilter() {
		return filter;
	}

	public void setFilter(String filter) {
		this.filter = filter;
	}
	
	public boolean equals(Object object) {
		if (object instanceof FilterLogUsingMatrixParameters) {
			FilterLogUsingMatrixParameters parameters = (FilterLogUsingMatrixParameters) object;
			return super.equals(parameters) &&
					getFilter().equals(parameters.getFilter()) &&
					isTryConnections() == parameters.isTryConnections();
		}
		return false;
	}

	public boolean isTryConnections() {
		return tryConnections;
	}

	public void setTryConnections(boolean tryConnections) {
		this.tryConnections = tryConnections;
	}
	
}
