package org.processmining.causalactivitymatrix.parameters;

import org.processmining.basicutils.parameters.impl.PluginParametersImpl;

public class ModifyCausalActivityMatrixParameters extends PluginParametersImpl {

	private double zeroValue;
	private double concurrencyRatio;
	private double includeThreshold;
	
	public ModifyCausalActivityMatrixParameters() {
		super();
		setZeroValue(0.0);
		setConcurrencyRatio(0.0);
		setIncludeThreshold(0.0);
	}
	
	public ModifyCausalActivityMatrixParameters(ModifyCausalActivityMatrixParameters parameters) {
		super(parameters);
		setZeroValue(parameters.getZeroValue());
		setConcurrencyRatio(parameters.getConcurrencyRatio());
		setIncludeThreshold(parameters.getIncludeThreshold());
	}
	
	public double getZeroValue() {
		return zeroValue;
	}
	
	public void setZeroValue(double zeroValue) {
		this.zeroValue = zeroValue;
	}
	
	public double getConcurrencyRatio() {
		return concurrencyRatio;
	}
	
	public void setConcurrencyRatio(double concurrencyRatio) {
		this.concurrencyRatio = concurrencyRatio;
	}
	
	public double getIncludeThreshold() {
		return includeThreshold;
	}
	
	public void setIncludeThreshold(double includeThreshold) {
		this.includeThreshold = includeThreshold;
	}
	
	public boolean equals(Object object) {
		if (object instanceof ModifyCausalActivityMatrixParameters) {
			ModifyCausalActivityMatrixParameters parameters = (ModifyCausalActivityMatrixParameters) object;
			return super.equals(parameters) && getZeroValue() == parameters.getZeroValue() &&
					getConcurrencyRatio() == parameters.getConcurrencyRatio() &&
					getIncludeThreshold() == parameters.getIncludeThreshold();
		}
		return false;
	}
}
