package org.processmining.causalactivitymatrix.plugins;

import javax.swing.JComponent;

import org.processmining.causalactivitymatrix.algorithms.VisualizeCausalActivityMatrixGridAlgorithm;
import org.processmining.causalactivitymatrix.models.CausalActivityMatrix;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.Visualizer;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;

public class VisualizeCausalActivityMatrixGridPlugin extends VisualizeCausalActivityMatrixGridAlgorithm {

	@Plugin(name = "@1 Visualize Causal Activity Matrix using Grid", returnLabels = { "Visualized Causal Activity Matrix" }, returnTypes = { JComponent.class }, parameterLabels = { "Causal Activity Matrix" })
	@Visualizer
	@PluginVariant(requiredParameterLabels = { 0 })
	public JComponent runUI(UIPluginContext context, CausalActivityMatrix matrix) {
		return apply(context, matrix);
	}

}
