package org.processmining.causalactivitymatrix.utils;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;

import org.deckfour.xes.classification.XEventClass;
import org.processmining.causalactivitymatrix.models.CausalActivityMatrix;
import org.processmining.causalactivitymatrix.models.impl.CausalActivityMatrixFactory;

public class CausalActivityMatrixModifiers {

	/**
	 * @deprecated Please use org.processmining.causalactivitymatrix.modfiers.impl.CausalActivityMatrixConcurrencyRatioModifier instead.
	 * @param matrix
	 * @param concurrencyRatio
	 * @return
	 */
	@Deprecated
	public static CausalActivityMatrix applyConcurrencyRatio(CausalActivityMatrix matrix, double concurrencyRatio) {
		CausalActivityMatrix newMatrix = CausalActivityMatrixFactory.createCausalActivityMatrix();
		newMatrix.init(matrix.getLabel(), new HashSet<XEventClass>(matrix.getActivities()));
		for (XEventClass activity : matrix.getActivities()) {
			for (XEventClass otherActivity : matrix.getActivities()) {
				double value = matrix.getValue(activity, otherActivity);
				double otherValue = matrix.getValue(otherActivity, activity);
				if (value > 0.0 && otherValue > 0.0 && !activity.equals(otherActivity)
						&& Math.abs(value - otherValue) < concurrencyRatio) {
					newMatrix.setValue(activity, otherActivity, -0.5);
				} else {
					newMatrix.setValue(activity, otherActivity, value);
				}
			}
		}
		return newMatrix;
	}

	/**
	 * @deprecated Please use org.processmining.causalactivitymatrix.modifiers.impl.CausalActivityMatrixZeroValueModifier instead.
	 * @param matrix
	 * @param zeroValue
	 * @return
	 */
	@Deprecated
	public static CausalActivityMatrix applyZeroValue(CausalActivityMatrix matrix, double zeroValue) {
		CausalActivityMatrix newMatrix = CausalActivityMatrixFactory.createCausalActivityMatrix();
		newMatrix.init(matrix.getLabel(), new HashSet<XEventClass>(matrix.getActivities()));
		for (XEventClass activity : matrix.getActivities()) {
			for (XEventClass otherActivity : matrix.getActivities()) {
				double value = matrix.getValue(activity, otherActivity);
				if (value == zeroValue) {
					value = 0.0;
				} else if (value > zeroValue) {
					value = (value >= 1.0 ? 1.0 : (value - zeroValue) / (1.0 - zeroValue));
				} else {
					value = (value <= -1.0 ? -1.0 : (value - zeroValue) / (1.0 + zeroValue));
				}
				newMatrix.setValue(activity, otherActivity, value);
			}
		}
		return newMatrix;
	}

	/**
	 * @deprecated Please use org.processmining.causalactivitymatrix.modifiers.impl.CausalActivityMatrixIncludeHresholdModifier instead.
	 * @param matrix
	 * @param zeroValue
	 * @return
	 */
	@Deprecated
	public static CausalActivityMatrix applyIncludeThreshold(CausalActivityMatrix matrix, double includeThreshold) {
		CausalActivityMatrix newMatrix = CausalActivityMatrixFactory.createCausalActivityMatrix();
		newMatrix.init(matrix.getLabel(), new HashSet<XEventClass>(matrix.getActivities()));
		Map<XEventClass, Double> maxValues = new HashMap<XEventClass, Double>();
		for (XEventClass activity : matrix.getActivities()) {
			maxValues.put(activity, matrix.getValue(activity, activity));
		}
		for (XEventClass activity : matrix.getActivities()) {
			for (XEventClass otherActivity : matrix.getActivities()) {
				double value = matrix.getValue(activity, otherActivity);
				if (value > maxValues.get(activity)) {
					maxValues.put(activity, value);
				}
				if (value > maxValues.get(otherActivity)) {
					maxValues.put(otherActivity, value);
				}
			}
		}
		for (XEventClass activity : matrix.getActivities()) {
			for (XEventClass otherActivity : matrix.getActivities()) {
				double maxValue = Math.min(maxValues.get(activity), maxValues.get(otherActivity));
				double value = matrix.getValue(activity, otherActivity);
				if (maxValue < 0.0) {
					value += includeThreshold;
					if (value == maxValue) {
						value = 0.0;
					} else if (value > maxValue) {
						value = (value >= 1.0 ? 1.0 : (value - maxValue) / (1.0 - maxValue));
					} else {
						value = (value <= -1.0 ? -1.0 : (value - maxValue) / (1.0 + maxValue));
					}
				}
				newMatrix.setValue(activity, otherActivity, value);
			}
		}
		return newMatrix;
	}
}
